Index: xine/demux_xvdr.c
===================================================================
RCS file: /cvsroot/xineliboutput/vdr-xineliboutput/xine/demux_xvdr.c,v
retrieving revision 1.31
diff -U2 -r1.31 demux_xvdr.c
--- xine/demux_xvdr.c	19 Feb 2010 11:58:00 -0000	1.31
+++ xine/demux_xvdr.c	17 Mar 2010 12:56:43 -0000
@@ -189,6 +192,17 @@
     int64_t diff = buf->pts - this->last_pts[video];
 
+    if (video &&
+        this->last_pts[video] < 14400 &&
+        buf->pts > (INT64_C(0x1ffffffff) - 14400) &&
+        !this->send_newpts) {
+      LOGMSG("VIDEO pts wrap in middle of GOP, ignoring video pts %" PRId64, buf->pts);
+      buf->pts = 0;
+      return;
+    }
+
     if (this->send_newpts || (this->last_pts[video] && abs(diff)>WRAP_THRESHOLD)) {
 
+      LOGVERBOSE("New PTS: %"PRId64" (%s)", buf->pts, video ? "VIDEO" : "AUDIO");
+
       if (this->buf_flag_seek) {
         _x_demux_control_newpts(this->stream, buf->pts, BUF_FLAG_SEEK);
